// Copyright (c) 2015, Herman Bergwerf. All rights reserved.
// Use of this source code is governed by a MIT-style license
// that can be found in the LICENSE file.

part of omnibus.patterns;

/// Module bootstrap function
typedef Future ModuleMain(Omnibus bus, http.Client httpClient);

/// Extension of [StateData] with no contents at all.
class EmptyState extends StateData {}

/// Extension of [StateData] that adds the parent bus and a shared HTTP client.
class SimpleState extends StateData {
  /// Parent bus
  Omnibus bus;

  /// Shared HTTP client
  http.Client httpClient;

  /// Constuctor
  SimpleState(this.bus, this.httpClient);
}
