// Copyright (c) 2016, Herman Bergwerf. All rights reserved.
// Use of this source code is governed by a MIT-style license
// that can be found in the LICENSE file.

// THIS FILE IS AUTO-GENERATED, PLEASE DO NOT MODIFY BY HAND.

part of omnibus.test.messages_lib;

/// Test messages that are used to test the Omnibus library.

/// Message that can hold String key/value pairs
class Data extends OmnibusEvent {
  /// omnibusId
  static const id = 'omnibus.v0.Data';

  /// Data map
  final Map<String, String> keyval;

  /// Constructor
  Data(this.keyval) : super(id);

  /// Construct from passive data structure.
  factory Data.fromPds(final Map<String, dynamic> pds) {
    Map<String, String> keyval;

    // Read keyval.
    if (pds.containsKey('keyval') && pds['keyval'] is Map) {
      keyval = new Map<String, String>.from(pds['keyval']);
    } else {
      throw new ArgumentError.value(
          pds, 'pds', "does not contain a valid field for property 'keyval'");
    }

    return new Data(keyval);
  }

  /// Generate passive data structure from message properties.
  Map<String, dynamic> toPds() {
    return {'keyval': keyval};
  }
}

/// Message handler for Data
class DataHandler extends OmnibusEventHandler {
  /// Callback
  final OmnibusEventCallback<Data> _callback;

  /// Constructor
  DataHandler(this._callback, StateData state) : super(Data.id, state);

  /// Process incoming message.
  Future<List<Future<Null>>> process(OmnibusEvent data) async {
    Data message = data is Data ? data : new Data.fromPds(data.toPds());

    return [_callback(message, state)];
  }
}

/// Message that has a, b, c values
class Abc extends OmnibusEvent {
  /// omnibusId
  static const id = 'omnibus.v0.Abc';

  final String a;

  final String b;

  final String c;

  /// Constructor
  Abc({this.a: '', this.b: '', this.c: ''}) : super(id);

  /// Construct from passive data structure.
  factory Abc.fromPds(final Map<String, dynamic> pds) {
    String a;
    String b;
    String c;

    // Read a.
    if (pds.containsKey('a') && pds['a'] is String) {
      a = pds['a'] as String;
    } else {
      throw new ArgumentError.value(
          pds, 'pds', "does not contain a valid field for property 'a'");
    }

    // Read b.
    if (pds.containsKey('b') && pds['b'] is String) {
      b = pds['b'] as String;
    } else {
      throw new ArgumentError.value(
          pds, 'pds', "does not contain a valid field for property 'b'");
    }

    // Read c.
    if (pds.containsKey('c') && pds['c'] is String) {
      c = pds['c'] as String;
    } else {
      throw new ArgumentError.value(
          pds, 'pds', "does not contain a valid field for property 'c'");
    }

    return new Abc(a: a, b: b, c: c);
  }

  /// Generate passive data structure from message properties.
  Map<String, dynamic> toPds() {
    return {'a': a, 'b': b, 'c': c};
  }
}

/// Message handler for Abc
class AbcHandler extends OmnibusEventHandler {
  /// Callback
  final OmnibusEventCallback<Abc> _callback;

  final String a;

  final String b;

  final String c;

  /// Constructor
  AbcHandler(this._callback, StateData state,
      {this.a: null, this.b: null, this.c: null})
      : super(Abc.id, state);

  /// Process incoming message.
  Future<List<Future<Null>>> process(OmnibusEvent data) async {
    Abc message = data is Abc ? data : new Abc.fromPds(data.toPds());

    if ((a == null || a == message.a) &&
        (b == null || b == message.b) &&
        (c == null || c == message.c)) {
      return [_callback(message, state)];
    } else {
      return [];
    }
  }
}

/// Fake request (also used to test for data parsing exceptions)
class FakeRequest extends OmnibusRequest {
  /// omnibusId
  static const id = 'omnibus.v0.FakeRequest';

  /// Data map
  final Map<String, List<int>> mapIntList;

  /// Data map
  final Map<String, List<bool>> mapBoolList;

  /// Constructor
  FakeRequest(this.mapIntList, this.mapBoolList) : super(id);

  /// Construct from passive data structure.
  factory FakeRequest.fromPds(final Map<String, dynamic> pds) {
    Map<String, List<int>> mapIntList;
    Map<String, List<bool>> mapBoolList;

    // Read mapIntList.
    if (pds.containsKey('mapIntList') && pds['mapIntList'] is Map) {
      mapIntList = pdsToStringMap(pds['mapIntList'] as Map<String, dynamic>,
              (List<int> item) => new List<int>.from(item))
          as Map<String, List<int>>;
    } else {
      throw new ArgumentError.value(pds, 'pds',
          "does not contain a valid field for property 'mapIntList'");
    }

    // Read mapBoolList.
    if (pds.containsKey('mapBoolList') && pds['mapBoolList'] is Map) {
      mapBoolList = pdsToStringMap(pds['mapBoolList'] as Map<String, dynamic>,
              (List<bool> item) => new List<bool>.from(item))
          as Map<String, List<bool>>;
    } else {
      throw new ArgumentError.value(pds, 'pds',
          "does not contain a valid field for property 'mapBoolList'");
    }

    return new FakeRequest(mapIntList, mapBoolList);
  }

  /// Generate passive data structure from message properties.
  Map<String, dynamic> toPds() {
    return {'mapIntList': mapIntList, 'mapBoolList': mapBoolList};
  }
}

/// Message handler for FakeRequest
class FakeRequestHandler extends OmnibusRequestHandler {
  /// Callback
  final OmnibusRequestCallback<FakeRequest> _callback;

  /// Constructor
  FakeRequestHandler(this._callback, StateData state)
      : super(FakeRequest.id, state);

  /// Process incoming message.
  Future<List<Future<OmnibusResponse>>> process(OmnibusRequest data) async {
    FakeRequest message =
        data is FakeRequest ? data : new FakeRequest.fromPds(data.toPds());

    return [_callback(message, state)];
  }
}

/// Fake response (also used to test OmnibusResponse.unchecked)
class FakeResponse extends OmnibusResponse {
  /// omnibusId
  static const id = 'omnibus.v0.FakeResponse';

  /// Constructor
  FakeResponse() : super(id);

  /// Construct from passive data structure.
  factory FakeResponse.fromPds(final Map<String, dynamic> pds) {
    return new FakeResponse();
  }

  /// Generate passive data structure from message properties.
  Map<String, dynamic> toPds() {
    return {};
  }
}

/// Create FakeResponse Stream from the given responses.
Stream<FakeResponse> streamFakeResponse(OmnibusResponses responses) {
  return responses.stream(
      FakeResponse.id,
      (OmnibusResponse data) => data is FakeResponse
          ? data
          : new FakeResponse.fromPds(data.toPds())) as Stream<FakeResponse>;
}

/// Filter-less event to test filtering
class MessageForAll extends OmnibusEvent {
  /// omnibusId
  static const id = 'omnibus.v0.MessageForAll';

  /// Message text
  final String message;

  /// Constructor
  MessageForAll(this.message) : super(id);

  /// Construct from passive data structure.
  factory MessageForAll.fromPds(final Map<String, dynamic> pds) {
    String message;

    // Read message.
    if (pds.containsKey('message') && pds['message'] is String) {
      message = pds['message'] as String;
    } else {
      throw new ArgumentError.value(
          pds, 'pds', "does not contain a valid field for property 'message'");
    }

    return new MessageForAll(message);
  }

  /// Generate passive data structure from message properties.
  Map<String, dynamic> toPds() {
    return {'message': message};
  }
}

/// Message handler for MessageForAll
class MessageForAllHandler extends OmnibusEventHandler {
  /// Callback
  final OmnibusEventCallback<MessageForAll> _callback;

  /// Constructor
  MessageForAllHandler(this._callback, StateData state)
      : super(MessageForAll.id, state);

  /// Process incoming message.
  Future<List<Future<Null>>> process(OmnibusEvent data) async {
    MessageForAll message =
        data is MessageForAll ? data : new MessageForAll.fromPds(data.toPds());

    return [_callback(message, state)];
  }
}

/// Email message
class Email extends OmnibusEvent {
  /// omnibusId
  static const id = 'omnibus.v0.Email';

  /// Sender
  final String sender;

  /// Receiver
  final String receiver;

  /// Message body
  final String body;

  /// Constructor
  Email(this.body, {this.sender: '', this.receiver: ''}) : super(id);

  /// Construct from passive data structure.
  factory Email.fromPds(final Map<String, dynamic> pds) {
    String sender;
    String receiver;
    String body;

    // Read sender.
    if (pds.containsKey('sender') && pds['sender'] is String) {
      sender = pds['sender'] as String;
    } else {
      throw new ArgumentError.value(
          pds, 'pds', "does not contain a valid field for property 'sender'");
    }

    // Read receiver.
    if (pds.containsKey('receiver') && pds['receiver'] is String) {
      receiver = pds['receiver'] as String;
    } else {
      throw new ArgumentError.value(
          pds, 'pds', "does not contain a valid field for property 'receiver'");
    }

    // Read body.
    if (pds.containsKey('body') && pds['body'] is String) {
      body = pds['body'] as String;
    } else {
      throw new ArgumentError.value(
          pds, 'pds', "does not contain a valid field for property 'body'");
    }

    return new Email(body, sender: sender, receiver: receiver);
  }

  /// Generate passive data structure from message properties.
  Map<String, dynamic> toPds() {
    return {'sender': sender, 'receiver': receiver, 'body': body};
  }
}

/// Message handler for Email
class EmailHandler extends OmnibusEventHandler {
  /// Callback
  final OmnibusEventCallback<Email> _callback;

  /// Sender
  final String sender;

  /// Receiver
  final String receiver;

  /// Constructor
  EmailHandler(this._callback, StateData state,
      {this.sender: null, this.receiver: null})
      : super(Email.id, state);

  /// Process incoming message.
  Future<List<Future<Null>>> process(OmnibusEvent data) async {
    Email message = data is Email ? data : new Email.fromPds(data.toPds());

    if ((sender == null || sender == message.sender) &&
        (receiver == null || receiver == message.receiver)) {
      return [_callback(message, state)];
    } else {
      return [];
    }
  }
}

/// Calculation request message
class CalculationRequest extends OmnibusRequest {
  /// omnibusId
  static const id = 'omnibus.v0.CalculationRequest';

  /// First input
  final double a;

  /// Second input
  final double b;

  /// Mathematical operator
  final CalculationOperator op;

  /// Constructor
  CalculationRequest(
      [this.a = 1.0, this.b = 1.0, this.op = CalculationOperator.add])
      : super(id);

  /// Construct from passive data structure.
  factory CalculationRequest.fromPds(final Map<String, dynamic> pds) {
    double a;
    double b;
    CalculationOperator op;

    // Read a.
    if (pds.containsKey('a') && pds['a'] is double) {
      a = pds['a'] as double;
    } else {
      throw new ArgumentError.value(
          pds, 'pds', "does not contain a valid field for property 'a'");
    }

    // Read b.
    if (pds.containsKey('b') && pds['b'] is double) {
      b = pds['b'] as double;
    } else {
      throw new ArgumentError.value(
          pds, 'pds', "does not contain a valid field for property 'b'");
    }

    // Read op.
    if (pds.containsKey('op') && pds['op'] is int) {
      op = CalculationOperator.values[pds['op']];
    } else {
      throw new ArgumentError.value(
          pds, 'pds', "does not contain a valid field for property 'op'");
    }

    return new CalculationRequest(a, b, op);
  }

  /// Generate passive data structure from message properties.
  Map<String, dynamic> toPds() {
    return {'a': a, 'b': b, 'op': op.index};
  }
}

/// Message handler for CalculationRequest
class CalculationRequestHandler extends OmnibusRequestHandler {
  /// Callback
  final OmnibusRequestCallback<CalculationRequest> _callback;

  /// Mathematical operator
  final CalculationOperator op;

  /// Constructor
  CalculationRequestHandler(this._callback, StateData state, {this.op: null})
      : super(CalculationRequest.id, state);

  /// Process incoming message.
  Future<List<Future<OmnibusResponse>>> process(OmnibusRequest data) async {
    CalculationRequest message = data is CalculationRequest
        ? data
        : new CalculationRequest.fromPds(data.toPds());

    if ((op == null || op == message.op)) {
      return [_callback(message, state)];
    } else {
      return [];
    }
  }
}

/// Calculation request response
class CalculationResponse extends OmnibusResponse {
  /// omnibusId
  static const id = 'omnibus.v0.CalculationResponse';

  /// Calculation result
  final CalculationResult result;

  /// Constructor
  CalculationResponse(this.result) : super(id);

  /// Construct from passive data structure.
  factory CalculationResponse.fromPds(final Map<String, dynamic> pds) {
    CalculationResult result;

    // Read result.
    if (pds.containsKey('result') && pds['result'] is double) {
      result = new CalculationResult.fromPds(pds['result']);
    } else {
      throw new ArgumentError.value(
          pds, 'pds', "does not contain a valid field for property 'result'");
    }

    return new CalculationResponse(result);
  }

  /// Generate passive data structure from message properties.
  Map<String, dynamic> toPds() {
    return {'result': result.toPds()};
  }
}

/// Create CalculationResponse Stream from the given responses.
Stream<CalculationResponse> streamCalculationResponse(
    OmnibusResponses responses) {
  return responses.stream(
          CalculationResponse.id,
          (OmnibusResponse data) => data is CalculationResponse
              ? data
              : new CalculationResponse.fromPds(data.toPds()))
      as Stream<CalculationResponse>;
}
