#!/bin/bash

# Copyright (c) 2015, Herman Bergwerf. All rights reserved.
# Use of this source code is governed by a MIT-style license
# that can be found in the LICENSE file.

# This script is executed by Travis CI after each push to GitHub. This script
# runs all Dart tests and sends the code coverage results to coveralls.io.

# Fast fail the script on failures.
set -e

# Run the tests.
pub run test

# If the COVERALLS_TOKEN token is set on travis:
# - Install dart_coveralls.
# - Rerun tests with coverage and send to coveralls.
if [ "$COVERALLS_TOKEN" ]; then
  pub global activate dart_coveralls
  pub global run dart_coveralls report \
  --token $COVERALLS_TOKEN \
  --retry 2 \
  --exclude-test-files \
  test/test_all.dart
fi
